import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*; 
import javax.swing.*; 
import javax.swing.event.*;
import java.io.*;
import javax.swing.filechooser.*;


/**
 * Clase tipo Frame que contiene el GUI del programa
 * Ademas realiza el manejo de archivos.
 * @author Juan Pablo Carvallo B.
*/
public class Editor extends JFrame implements ActionListener
{
    
/**
 * Panel principal, en que se ubican los dems paneles
 */
private MainPanel principal = new MainPanel();
private JMenuBar barra = new JMenuBar();
private JMenu menu = new JMenu("Archivo");
private JMenu menu2 = new JMenu("Edicion");
private JMenuItem cargar, guardar, salir, borrar;
private JFileChooser selector;

private PrintWriter pwout;
private ArrayList xfigs;
private String header;
private String subheader;
private final double r = 17;

private final int wHeight = 560;
private final int wWidth  = 700;
  
  
 /**
 * Constructor. Crea un nuevo Frame para contener el GUI
 */
 public Editor() 
 {  
 cargar = new JMenuItem("Cargar ...");
 guardar = new JMenuItem("Guardar ...");
 salir = new JMenuItem("Salir");
 borrar = new JMenuItem("Borrar figuras");
 menu.add(cargar);
 menu.add(guardar);
 menu.add(salir);
 menu2.add(borrar);
 barra.add(menu);
 barra.add(menu2);
 setJMenuBar(barra);
 
 setTitle("Figuras en Java - Juan Pablo Carvallo"); 
 setSize(wWidth, wHeight);
 setContentPane(principal);
 setVisible(true);
 setDefaultCloseOperation(this.EXIT_ON_CLOSE);
 
 selector = new JFileChooser();
 selector.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
 selector.addChoosableFileFilter(new ImageFilter());
 
 salir.addActionListener(this);
 cargar.addActionListener(this);
 guardar.addActionListener(this);
 borrar.addActionListener(this);
 }
 /**
 * Mtodo Main. Se crea una instancia de Frame
 * @param args Usar sin argumentos.
 */    
  public static void main(String[] args)
  { 
    Editor editor = new Editor();   
  }
 
 /**
  * El mtodo actionPerformed asociado a los eventos del Menu
  * @param e El evento de oprimir un item de menu
  */ 
  public void actionPerformed(ActionEvent e)
  {
   if (e.getSource() != guardar)
   { if (principal.getgui3().isEdited())
     { int n = JOptionPane.showConfirmDialog(
       this, "Desea guardar los cambios?",
       "Advertencia", JOptionPane.YES_NO_OPTION);
       if (n == 0)
       { callGuardar(); }
     }
     if (e.getSource() == salir)
     { System.exit(0); }
     if (e.getSource() == borrar)
     { principal.getgui3().initt();
       principal.getgui3().setEvento(true); principal.getgui3().paintt(); }
     if (e.getSource() == cargar)
     {  int returnVal = selector.showOpenDialog(Editor.this);
        if (returnVal == JFileChooser.APPROVE_OPTION) 
        {   File file = selector.getSelectedFile();
           try 
           { openEda(file);
           } 
           catch (FileNotFoundException et)
           { System.err.println("Error! No esta el archivo");
             System.exit(1); 
           } 
           catch (IOException et)
           { System.err.println("Error! Mal IO"); System.exit(1);
           } 
           catch (ClassNotFoundException et)
           { System.err.println("Error! No esta la clase");
             System.exit(1); }  
        }
      }
    }
   else
   { if (e.getSource() == guardar)
     { callGuardar(); }
   }
  } //End Actionperformed
  
  protected void callGuardar()
  { principal.getgui3().setEdited(false);
     int returnVal = selector.showSaveDialog(Editor.this);
     if (returnVal == JFileChooser.APPROVE_OPTION) 
     {     File file = selector.getSelectedFile();
           try
           { saveXfig(file);
           } 
           catch (FileNotFoundException et)
           { System.err.println("Error! No esta el archivo");
             System.exit(1); }
           try
           { saveEda(file);
           } 
           catch (FileNotFoundException et)
           { System.err.println("Error! No esta el archivo");
             System.exit(1); 
           } 
           catch (IOException et)
           { System.err.println("Error! Mal IO");
             System.exit(1); }         
        }
     }
  
  //FileNotFoundException, 
  protected void openEda (File openEdaFile) throws IOException, 
     ClassNotFoundException
  {
  FileInputStream fstream = new FileInputStream(openEdaFile);
  ObjectInputStream oosin = new ObjectInputStream(fstream);
  
  principal.getgui3().initt();
  int edasize = oosin.readInt();
  for (int i = 0; i < edasize; i++)
  { oosin.readObject(); }
  final int S = 3;
  double[] recupT = new double[S];
  recupT[0] = oosin.readDouble();
  recupT[1] = oosin.readDouble();
  recupT[2] = oosin.readDouble();
  principal.getgui3().setT(recupT);
  principal.getgui3().paintt();
    
  oosin.close();
  }

  //FileNotFoundException,
  protected void saveEda (File saveEdaFile) throws IOException
  {
  String rect = "java.awt.geom.Rectangle2D$Double";
  String circ = "java.awt.geom.Ellipse2D$Double";
  String poly = "java.awt.geom.Line2D$Double";
  
  File saveEdaFileExt = new File(saveEdaFile + ".eda");
  FileOutputStream fstream = new FileOutputStream(saveEdaFileExt);
  ObjectOutputStream oosout = new ObjectOutputStream(fstream);
  
  ArrayList edafigs = principal.getgui3().getArrayList();
      
  oosout.writeInt(edafigs.size());
  
  for (int i = 0; i < edafigs.size(); i++)
  {
  String figname = edafigs.get(i).getClass().getName(); 
  if (figname.equals(poly) | figname.equals("MyLine"))
    { Line2D.Double tmpPoly = (Line2D.Double)edafigs.get(i);
      MyLine edaPoly = new MyLine(tmpPoly.getX1(), tmpPoly.getY1(),
            tmpPoly.getX2(), tmpPoly.getY2());
      oosout.writeObject(edaPoly); }
  if (figname.equals(rect) | figname.equals("MyRect"))
    { Rectangle2D.Double tmpRect = (Rectangle2D.Double)edafigs.get(i);
      MyRect edaRect = new MyRect(tmpRect.getX(), tmpRect.getY(),
            tmpRect.getWidth(), tmpRect.getHeight());
      oosout.writeObject(edaRect); }
  if (figname.equals(circ) | figname.equals("MyCirc"))
    { Ellipse2D.Double tmpCirc = (Ellipse2D.Double)edafigs.get(i);
      MyCirc edaCirc = new MyCirc(tmpCirc.getX(), tmpCirc.getY(),
            tmpCirc.getWidth(), tmpCirc.getHeight());
      oosout.writeObject(edaCirc); }
    } //Close for
    
    double[] arrayRet = principal.getgui3().getT();
    oosout.writeDouble(arrayRet[0]); //Angulo   
    oosout.writeDouble(arrayRet[1]); //AnchorX
    oosout.writeDouble(arrayRet[2]); //AnchorY
    oosout.close();
  }

  
  protected void saveXfig (File saveFigFile) throws FileNotFoundException
  {
   /*Como Xfig usa 1200 ppp, una pantalla de 800x600 tiene app
     70 ppp. Con esto, como las coord. de Java estn en pixels
     tengo 1200/70 =~ 17 para convertir unidades*/
  
  File saveFigFileExt = new File(saveFigFile + ".fig");
  FileOutputStream fstream = new FileOutputStream(saveFigFileExt);
  pwout = new PrintWriter(new BufferedOutputStream(fstream));
  
  xfigs = principal.getgui3().getArrayList();
  header = "#FIG 3.2" + "\nPortrait" + "\nCenter" + "\nMetric"
       + "\nA4" + "\n100.0" + "\nSingle" + "\n-2" + "\n1200 2";
  subheader = " 0" + " 1" + " 0" + " 0" 
       + " 100" + " 1" + " -1" + "  6.40";
  pwout.print(header);
  for (int i = 0; i < xfigs.size(); i++)
  { if (xfigs.get(i).getClass().getName().equals("MyRect"))
    {
     saveRectFig(i);
    }
  
  if (xfigs.get(i).getClass().getName().equals("MyCirc"))
  { 
   saveCircFig(i);
  }
  
  if (xfigs.get(i).getClass().getName().equals("MyLine"))
  { 
   savePolyFig(i);
   } 
  }
  pwout.close();
  }

protected void saveRectFig (int i)
{ String type = "\n2" + " 2";
    String postSubheader = " 0" + " 0" + " 0" + " 0" + " 0" + " 5";
    pwout.print(type + subheader + postSubheader);
    Rectangle2D.Double tmpRect = (Rectangle2D.Double)xfigs.get(i);
    double x = tmpRect.getX() * r;
    double y = tmpRect.getY() * r;
    double an = tmpRect.getWidth() * r;
    double al = tmpRect.getHeight() * r; 

    int c1x = (int)x; int c1y = (int)y;
    int c2x = (int)(x + an); int c2y = (int)y;
    int c3x = (int)(x + an); int c3y = (int)(y + al);
    int c4x = (int)x;      int c4y = (int)(y + al);
    String rconfig = "\n" + c1x + " " + c1y + " " + c2x + " "
     + c2y + " " + c3x + " " + c3y + " " + c4x + " " + c4y 
     + " " + c1x + " " + c1y;
    pwout.print(rconfig);
}

protected void saveCircFig (int i)
{ final double F = 0.5;
   String type = "\n1" + " 1";
   String postSubheader = " 1" + " 0.0";
   pwout.print(type + subheader + postSubheader);
   Ellipse2D.Double tmpCirc = (Ellipse2D.Double)xfigs.get(i);
   double x = tmpCirc.getX() * r;
   double y = tmpCirc.getY() * r;
   double an = tmpCirc.getWidth() * r;
   double al = tmpCirc.getHeight() * r;

   int c1x = (int)(x + F * an); int c1y = (int)(y + F * al); //Centro
   int c2x = (int)(F * an);     int c2y = (int)(F * al);     //Radio
   int c3x = (int)x;            int c3y = (int)y;            //Start
   int c4x = (int)(x + an);     int c4y = (int)(y + al);     //End
   String cconfig = " " + c1x + " " + c1y + " " + c2x + " " + c2y + " " 
       + c3x + " " + c3y + " " + c4x + " " + c4y;
   pwout.print(cconfig); 
}

protected void savePolyFig (int i)
{ String type = "\n2" + " 1";
   String postSubheader = " 0" + " 0" + " 12" + " 0" + " 0" + " 2";
   pwout.print(type + subheader + postSubheader);
   Line2D.Double tmpPoly = (Line2D.Double)xfigs.get(i);
   int x1 = (int)(tmpPoly.getX1() * r);
   int y1 = (int)(tmpPoly.getY1() * r);
   int x2 = (int)(tmpPoly.getX2() * r);
   int y2 = (int)(tmpPoly.getY2() * r);

   String pconfig = "\n" + x1 + " " + y1 + " " + x2 + " " + y2;
   pwout.print(pconfig);
}

}
