import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/** 
 * Clase que extiende de FileFilter para permitir 
 * el filtrado de archivos y ver solo los .eda 
 */

public class ImageFilter extends FileFilter
{ private final String eda = "eda";
 
/**  
 * Define si sera aceptado o no un archivo dado en un directorio  
 * determinado.
 * @param f Un archivo
 * @return Verdadero o falso, segun si el archivo coincide con  
 *         la extension requerida.  
 */
  
public boolean accept(File f) 
{
      if (f.isDirectory()) 
      { return true; }
      String extension = getExtension(f);
      if (extension != null) 
      {  if (extension.equals(eda)) 
         { return true; } 
         else 
         { return false; }
       }      
  return false;
    }

 /**
  * Entrega la descripcion para este filtro
  * @return La descripcion.
  */ 

  public String getDescription() 
  {
   return "EDA files";  }

  /**
   * Obtiene la extension de un archivo
   * @param f El archivo del cual se desea saber la extension
   * @return El String conteniendo la extension
   */ 
  protected String getExtension(File f) 
  {   String ext = null;
      String s = f.getName();
      int i = s.lastIndexOf('.');
      if (i > 0 &&  i < s.length() - 1)
      { ext = s.substring(i + 1).toLowerCase(); }
     return ext;
  }
 }
