import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*; 
import javax.swing.*; 
import javax.swing.event.*;

/** 
 * Clase que crea el panel principal, que contiene los dems paneles.
 * @author Juan Pablo Carvallo B.
 */
public class MainPanel extends JRootPane
{

/**
 * Panel para botones de Figura
 */
private PanelFiguras gui = new PanelFiguras();
/**
 * Panel para botones de Accion
 */
private PanelAcciones gui2 = new PanelAcciones();
/**
 * Panel para dibujar
 */
private DrawingPanel gui3 = new DrawingPanel();
/**
 * Define el layout a utilizar para ordenar los paneles
 */
private SpringLayout layout = new SpringLayout();

private final int doscientos = 200;
private final int cinco = 5;
private final int menosCinco = -5;

//Constructor
/**
 * Constructor. Define el layout para los objetos (paneles) 
 * y agrega estos ltimos.
 */
public MainPanel()
{
setLayout(layout);
layout.putConstraint(SpringLayout.WEST, gui, 
   cinco, SpringLayout.WEST, this); 
layout.putConstraint(SpringLayout.NORTH, gui, 
   cinco, SpringLayout.NORTH, this);

layout.putConstraint(SpringLayout.WEST, gui2, 
   cinco, SpringLayout.WEST, this); 
layout.putConstraint(SpringLayout.NORTH, gui2, 
   cinco, SpringLayout.SOUTH, gui);

layout.putConstraint(SpringLayout.WEST, gui3, 
   doscientos, SpringLayout.WEST, this);
layout.putConstraint(SpringLayout.NORTH, gui3, 
   cinco, SpringLayout.NORTH, this);

layout.putConstraint(SpringLayout.EAST, gui, 
   menosCinco, SpringLayout.WEST, gui3);
layout.putConstraint(SpringLayout.EAST, gui2, 
   menosCinco, SpringLayout.WEST, gui3);

layout.putConstraint(SpringLayout.EAST, this, 
   cinco, SpringLayout.EAST, gui3);
layout.putConstraint(SpringLayout.SOUTH, this, 
   cinco, SpringLayout.SOUTH, gui3);

add(gui);
add(gui2);
add(gui3); 
setOpaque(true);
 }
 
 /**
  * Permite acceso al atributo gui3, es decir,
  * el panel de dibujo
  * @return El panel de dibujo
  */
 public DrawingPanel getgui3()
 {
  return gui3;
 }
 
}
