import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*; 
import javax.swing.*; 
import javax.swing.event.*;


/**
 * Clase tipo Panel, para crear el panel de Figuras
 * @author Juan Pablo Carvallo B.
 */
public class PanelFiguras extends JPanel
{

  //Atributos
/**
 * Boton para crear Circulos
 */  
  private Botones circleButton = new Botones("Circulo", "imagecirc.gif");
/**
 * Boton para crear Rectangulos
 */
  private Botones rectButton = new Botones("Rectangulo", "imagerect.gif");
/**
 * Boton para crear Polylines
 */
  private Botones polyButton = new Botones("Polyline", "imagepoly.gif");
/**
 * Grupo de botones para funcionalidad Toggle
 */
  private static ButtonGroup grupo = new ButtonGroup();
/**
 * Objeto para atender la actividad de los botones
 */
  private ButtonHandler listener = new ButtonHandler();
  
  private final int dWidth = 190;
  private final int dHeight = 245;
  private final int red = 220;
  private final int green = 130;
  private final int blue = 150;
 
  
  //Constructor
/**
 * Constructor Crea el panel de botones para crear Figuras.
 */
  public PanelFiguras()
  {
   setOpaque(true);
   setBorder(BorderFactory.createLineBorder(Color.black));
   setBackground(new Color(red, green, blue));
   grupo.add(circleButton); 
   grupo.add(rectButton);
   grupo.add(polyButton);
   circleButton.setToolTipText("Uso: MouseIzq dibuja; MouseDer termina dibujo");
   rectButton.setToolTipText("Uso: MouseIzq dibuja; MouseDer termina dibujo");
   polyButton.setToolTipText("Uso: MouseIzq dibuja 1 linea" 
      + "; DobleClick dibuja otra linea; MouseDer termina dibujo");
   add(circleButton); 
   add(rectButton);
   add(polyButton);
   
   circleButton.addActionListener(listener);
   rectButton.addActionListener(listener);
   polyButton.addActionListener(listener);
  }
  
/**
 * Retorna el grupo en que se asociaron los botones de Figuras.
 * @return el <tt>grupo</tt> que asocia los botones de Figura.
 */
  public static ButtonGroup getGroup()
  {
    return grupo;
  }
  
/**
 * Retorna tamao mnimo preferido, que se ha hecho igual al preferido.
 * @return el <tt>tamao preferido</tt>.
 */
  public Dimension getMinimumSize()
  {
    return getPreferredSize();
  }
  
/**
 * Retorna tamao preferido, diseado para visualizacin correcta en pantalla.
 * @return el <tt>tamao preferido</tt>.
 */
  public Dimension getPreferredSize()
  {
    return new Dimension (dWidth, dHeight);
  }
  
/**
 * Retorna tamao mximo preferido, que se ha hecho igual al preferido.
 * @return el <tt>tamao preferido</tt>.
 */
  public Dimension getMaximumSize()
  {
    return getPreferredSize();
  }

 }
